// ◇ UTF-8

#define LOG_SUBTAG    "nativetest"
#define LOGV_ENABLE 0
#define LOGD_ENABLE 0
#define LOGI_ENABLE 1

#include "nativetest.h"

// =====================================================================
// 入力イベント処理
// =====================================================================

static int engine_handle_input(struct android_app* app, AInputEvent* event)
{
	LOGD("start");

	switch (AInputEvent_getType(event)) {
	  case AINPUT_EVENT_TYPE_KEY:
		{
			int action = AKeyEvent_getAction(event);
			int keycode = AKeyEvent_getKeyCode(event);
			if (action == 1) {
				// OnKeyUp KEY
				if (keycode == AKEYCODE_BACK) {
					// [Back]ボタン
					LOGW("end: Finish by [Back] button");
					ANativeActivity_finish(app->activity);
					return 1;
				}
			}
		}
	}

	LOGD("end: no input");
	return 0;
}

// =====================================================================
// Native Activityエントリポイント
// =====================================================================

void android_main(struct android_app* app)
{
	LOGI("start");

	// android_native_app_glue接続用
	app_dummy();

	// libandroid.so内の関数呼び出しテスト
	AConfiguration_new();

	app->onInputEvent = engine_handle_input;

	// メインループ
	while (!0) {
		// イベント処理
		while (!0) {
			int ident;
			int events;
			struct android_poll_source* source;

			ident = ALooper_pollAll(0, NULL, &events, (void**)&source);
			if (ident < 0) break;

			if (source != NULL) {
				source->process(app, source);
			}

			// 終了要請があったらループout
			if (app->destroyRequested != 0) {
				break;
			}
		}

		// 終了要請があったらループout
		if (app->destroyRequested != 0) {
			break;
		}
	}

	LOGI("end");
}

// [EOF}
